二分图最大权匹配(KM算法)

来源:互联网 发布:tsp问题算法 编辑:程序博客网 时间:2024/04/29 15:14

KM算法是通过给每个顶点一个标号(叫做顶标)来把求最大权匹配的问题转化为求完备匹配的问题的。设顶点Xi的顶标为A[i],顶点Yi的顶标为B [i],顶点XiYj之间的边权为w[i,j]。在算法执行过程中的任一时刻,对于任一条边(i,j)A[i]+B[j]>=w[i,j]始终 成立。KM算法的正确性基于以下定理:
   若由二分图中所有满足A[i]+B[j]=w[i,j]的边(i,j)构成的子图(称做相等子图)有完备匹配,那么这个完备匹配就是二分图的最大权匹配。
  这个定理是显然的。因为对于二分图的任意一个匹配,如果它包含于相等子图,那么它的边权和等于所有顶点的顶标和;如果它有的边不包含于相等子图,那么它的边权和小于所有顶点的顶标和。所以相等子图的完备匹配一定是二分图的最大权匹配。
   初始时为了使A[i]+B[j]>=w[i,j]恒成立,令A[i]为所有与顶点Xi关联的边的最大权,B[j]=0。如果当前的相等子图没有完备匹配,就按下面的方法修改顶标以使扩大相等子图,直到相等子图具有完备匹配为止。
   我们求当前相等子图的完备匹配失败了,是因为对于某个X顶点,我们找不到一条从它出发的交错路。这时我们获得了一棵交错树,它的叶子结点全部是X顶点。现在我们把交错树中X顶点的顶标全都减小某个值dY顶点的顶标全都增加同一个值d,那么我们会发现:
 两端都在交错树中的边(i,j)A[i]+B[j]的值没有变化。也就是说,它原来属于相等子图,现在仍属于相等子图。
 两端都不在交错树中的边(i,j)A[i]B[j]都没有变化。也就是说,它原来属于(或不属于)相等子图,现在仍属于(或不属于)相等子图。
 X端不在交错树中,Y端在交错树中的边(i,j),它的A[i]+B[j]的值有所增大。它原来不属于相等子图,现在仍不属于相等子图。
 X端在交错树中,Y端不在交错树中的边(i,j),它的A[i]+B[j]的值有所减小。也就说,它原来不属于相等子图,现在可能进入了相等子图,因而使相等子图得到了扩大。
   现在的问题就是求d值了。为了使A[i]+B[j]>=w[i,j]始终成立,且至少有一条边进入相等子图,d应该等于min{A[i]+B[j]-w[i,j]|Xi在交错树中,Yi不在交错树中}
   以上就是KM算法的基本思路。但是朴素的实现方法,时间复杂度为O(n4)——需要找O(n)次增广路,每次增广最多需要修改O(n)次顶 标,每次修改顶标时由于要枚举边来求d值,复杂度为O(n2)。实际上KM算法的复杂度是可以做到O(n3)的。我们给每个Y顶点一个松弛量函数 slack,每次开始找增广路时初始化为无穷大。在寻找增广路的过程中,检查边(i,j)时,如果它不在相等子图中,则让slack[j]变成原值与A [i]+B[j]-w[i,j]的较小值。这样,在修改顶标时,取所有不在交错树中的Y顶点的slack值中的最小值作为d值即可。但还要注意一点:修改 顶标后,要把所有的slack值都减去d


hdu 2255

奔小康赚大钱

Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4448    Accepted Submission(s): 1915


Problem Description
传说在遥远的地方有一个非常富裕的村落,有一天,村长决定进行制度改革:重新分配房子。
这可是一件大事,关系到人民的住房问题啊。村里共有n间房间,刚好有n家老百姓,考虑到每家都要有房住(如果有老百姓没房子住的话,容易引起不安定因素),每家必须分配到一间房子且只能得到一间房子。
另一方面,村长和另外的村领导希望得到最大的效益,这样村里的机构才会有钱.由于老百姓都比较富裕,他们都能对每一间房子在他们的经济范围内出一定的价格,比如有3间房子,一家老百姓可以对第一间出10万,对第2间出2万,对第3间出20万.(当然是在他们的经济范围内).现在这个问题就是村领导怎样分配房子才能使收入最大.(村民即使有钱购买一间房子但不一定能买到,要看村领导分配的).
 

Input
输入数据包含多组测试用例,每组数据的第一行输入n,表示房子的数量(也是老百姓家的数量),接下来有n行,每行n个数表示第i个村名对第j间房出的价格(n<=300)。
 

Output
请对每组数据输出最大的收入值,每组的输出占一行。

 

Sample Input
2100 1015 23
 

Sample Output
123
 

<span style="font-family:KaiTi_GB2312;font-size:18px;">#include <cstdio>#include <iostream>#include <cstring>#include <cmath>#include <algorithm>#include <string.h>#include <string>#include <vector>#include <queue>#define MEM(a,x) memset(a,x,sizeof a)#define eps 1e-8#define MOD 10009#define MAXN 10010#define INF 0x3f3f3f3f#define ll __int64#define bug cout<<"here"<<endl#define fread freopen("ceshi.txt","r",stdin)#define fwrite freopen("out.txt","w",stdout)using namespace std;void read(int &x){    char ch;    x=0;    while(ch=getchar(),ch!=' '&&ch!='\n')    {        x=x*10+ch-'0';    }}const int N=310;int nx,ny;//两边的点数int g[N][N];//二分图描述int linker[N],lx[N],ly[N];//y中各点匹配状态 x,y中的点标号int slack[N];bool visx[N],visy[N];bool DFS(int x){    visx[x]=1;    for(int y=0;y<ny;y++)    {        if(visy[y]) continue;        int tmp=lx[x]+ly[y]-g[x][y];        if(tmp==0)        {            visy[y]=1;            if(linker[y]==-1||DFS(linker[y]))            {                linker[y]=x;                return 1;            }        }        else if(slack[y]>tmp)            slack[y]=tmp;    }    return 0;}int KM(){    MEM(linker,-1);    MEM(ly,0);    for(int i=0;i<nx;i++)    {        lx[i]=-INF;        for(int j=0;j<ny;j++)        {            if(g[i][j]>lx[i])                lx[i]=g[i][j];        }    }    for(int x=0;x<nx;x++)    {        for(int i=0;i<ny;i++)            slack[i]=INF;        while(1)        {            MEM(visx,0);            MEM(visy,0);            if(DFS(x))  break;            int d=INF;            for(int i=0;i<ny;i++)                if(!visy[i]&&d>slack[i])                    d=slack[i];            for(int i=0;i<nx;i++)                if(visx[i])                    lx[i]-=d;            for(int i=0;i<ny;i++)            {                if(visy[i])  ly[i]+=d;                else slack[i]-=d;            }        }    }    int res=0;    for(int i=0;i<ny;i++)        if(linker[i]!=-1)            res+=g[linker[i]][i];    return res;}int main(){//    fread;    int n;    while(scanf("%d",&n)!=EOF)    {        for(int i=0;i<n;i++)            for(int j=0;j<n;j++)                scanf("%d",&g[i][j]);        nx=ny=n;        printf("%d\n",KM());    }    return 0;}</span>
ps:感谢Kuangbin提供的模板


poj 2195 

Going Home
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 18703 Accepted: 9551

Description

On a grid map there are n little men and n houses. In each unit time, every little man can move one unit step, either horizontally, or vertically, to an adjacent point. For each little man, you need to pay a $1 travel fee for every step he moves, until he enters a house. The task is complicated with the restriction that each house can accommodate only one little man. 

Your task is to compute the minimum amount of money you need to pay in order to send these n little men into those n different houses. The input is a map of the scenario, a '.' means an empty space, an 'H' represents a house on that point, and am 'm' indicates there is a little man on that point. 

You can think of each point on the grid map as a quite large square, so it can hold n little men at the same time; also, it is okay if a little man steps on a grid with a house without entering that house.

Input

There are one or more test cases in the input. Each case starts with a line giving two integers N and M, where N is the number of rows of the map, and M is the number of columns. The rest of the input will be N lines describing the map. You may assume both N and M are between 2 and 100, inclusive. There will be the same number of 'H's and 'm's on the map; and there will be at most 100 houses. Input will terminate with 0 0 for N and M.

Output

For each test case, output one line with the single integer, which is the minimum amount, in dollars, you need to pay.

Sample Input

2 2.mH.5 5HH..m...............mm..H7 8...H.......H.......H....mmmHmmmm...H.......H.......H....0 0

Sample Output

21028

这道题之前使用最小费用流写的 用二分图最大权匹配也可以做

#include <cstdio>#include <iostream>#include <cstring>#include <cmath>#include <algorithm>#include <string.h>#include <string>#include <vector>#include <queue>#define MEM(a,x) memset(a,x,sizeof a)#define eps 1e-8#define MOD 10009#define MAXN 10010#define INF 0x3f3f3f3f#define ll __int64#define bug cout<<"here"<<endl#define fread freopen("ceshi.txt","r",stdin)#define fwrite freopen("out.txt","w",stdout)using namespace std;void read(int &x){    char ch;    x=0;    while(ch=getchar(),ch!=' '&&ch!='\n')    {        x=x*10+ch-'0';    }}const int N=310;int nx,ny;//两边的点数int g[N][N];//二分图描述int linker[N],lx[N],ly[N];//y中各点匹配状态 x,y中的点标号int slack[N];bool visx[N],visy[N];bool DFS(int x){    visx[x]=1;    for(int y=0;y<ny;y++)    {        if(visy[y]) continue;        int tmp=lx[x]+ly[y]-g[x][y];        if(tmp==0)        {            visy[y]=1;            if(linker[y]==-1||DFS(linker[y]))            {                linker[y]=x;                return 1;            }        }        else if(slack[y]>tmp)            slack[y]=tmp;    }    return 0;}int KM(){    MEM(linker,-1);    MEM(ly,0);    for(int i=0;i<nx;i++)    {        lx[i]=-INF;        for(int j=0;j<ny;j++)        {            if(g[i][j]>lx[i])                lx[i]=g[i][j];        }    }    for(int x=0;x<nx;x++)    {        for(int i=0;i<ny;i++)            slack[i]=INF;        while(1)        {            MEM(visx,0);            MEM(visy,0);            if(DFS(x))  break;            int d=INF;            for(int i=0;i<ny;i++)                if(!visy[i]&&d>slack[i])                    d=slack[i];            for(int i=0;i<nx;i++)                if(visx[i])                    lx[i]-=d;            for(int i=0;i<ny;i++)            {                if(visy[i])  ly[i]+=d;                else slack[i]-=d;            }        }    }    int res=0;    for(int i=0;i<ny;i++)        if(linker[i]!=-1)            res+=g[linker[i]][i];    return res;}int x[1100],y[1100];char ch[110][110];int main(){//    fread;    int n,m;    while(scanf("%d%d",&n,&m)!=EOF)    {        if(n==0&&m==0)  break;        for(int i=0;i<n;i++)            scanf("%s",ch[i]);        int num=0;        for(int i=0;i<n;i++)        {            for(int j=0;j<m;j++)            {                if(ch[i][j]=='m')                {                    num++;                    x[num]=i;y[num]=j;                }            }        }        int cnt=0;        for(int i=0;i<n;i++)        {            for(int j=0;j<m;j++)            {                if(ch[i][j]=='H')                {                    cnt++;                    x[num+cnt]=i;y[num+cnt]=j;                }            }        }        for(int i=1;i<=num;i++)        {            for(int j=1;j<=cnt;j++)            {                int val=abs(x[i]-x[num+j])+abs(y[i]-y[num+j]);                g[i-1][j-1]=-val;            }        }        nx=num; ny=cnt;        printf("%d\n",-KM());    }    return 0;}



0 0
原创粉丝点击